组合
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/combinations/
问题叙述
给定两个整数 n 和 k,返回范围 [1, n] 中所有可能的 k 个数的组合。
你可以按 任何顺序 返回答案。
示例 1
输入:n = 4, k = 2
输出:
[
[2,4],
[3,4],
[2,3],
[1,2],
[1,3],
[1,4],
]
示例 2
输入:n = 1, k = 1
输出:[[1]]
提示
1 <= n <= 20
1 <= k <= n
分析
图源:力扣liweiwei1419
抽象成树形结构
用一个名为path的双端队列来存储我们所需要的的组合
当我们path的长度 等于 k 的长度时
也就是满足了k个数的组合的条件 将此时满足条件的path加入到结果中
然后我们回溯 将path的最后一个元素移除 并重复这个过程
由于每个数字只能用一次 所以递归时startIndex的参数值设为i+1
优质题解
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> combine (int n, int k) { backTracking(n, k, 1 ); return res; } void backTracking (int n, int k, int startIndex) { if (path.size() == k) { res.add(new ArrayList <>(path)); return ; } for (int i = startIndex; i <= n - (k - path.size()) + 1 ; i++) { path.offer(i); backTracking(n, k, i + 1 ); path.removeLast(); } } }
组合总和III
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/combination-sum-iii/
问题叙述
找出所有相加之和为 n 的 k 个数的组合,且满足下列条件:
只使用数字1到9
每个数字 最多使用一次
返回 所有可能的有效组合的列表 。该列表不能包含相同的组合两次,组合可以以任何顺序返回。
示例 1
输入: k = 3, n = 7
输出: [[1,2,4]]
解释:
1 + 2 + 4 = 7
没有其他符合的组合了。
示例 2
输入: k = 3, n = 9
输出: [[1,2,6], [1,3,5], [2,3,4]]
解释:
1 + 2 + 6 = 9
1 + 3 + 5 = 9
2 + 3 + 4 = 9
没有其他符合的组合了。
示例 3
输入: k = 4, n = 1
输出: []
解释: 不存在有效的组合。
在[1,9]范围内使用4个不同的数字,我们可以得到的最小和是1+2+3+4 = 10,因为10 > 1,没有有效的组合。
提示
2 <= k <= 9
1 <= n <= 60
分析
每个数字只能用一次 跟上题一样 递归时startIndex的参数值设为i+1
还是画出树状结构 做减法 减到0即说明找到了符合条件的path值
如果减到负数就直接剪枝 当前分支只会越减越小 不可能为0了
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> combinationSum3 (int k, int n) { backTracking(k, n, 1 ); return res; } void backTracking (int k, int n, int startIndex) { if (n < 0 ) return ; if (path.size() == k && n == 0 ) { res.add(new ArrayList <>(path)); return ; } for (int i = startIndex; i <= 9 ; i++) { path.offer(i); backTracking(k, n - i, i + 1 ); path.removeLast(); } } }
电话号码的字母组合
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/letter-combinations-of-a-phone-number/
问题叙述
给定一个仅包含数字 2-9 的字符串,返回所有它能表示的字母组合。答案可以按 任意顺序 返回。
给出数字到字母的映射如下(与电话按键相同)。注意 1 不对应任何字母。
示例 1
输入:digits = “23”
输出:[“ad”,“ae”,“af”,“bd”,“be”,“bf”,“cd”,“ce”,“cf”]
示例 2
输入:digits = “”
输出:[]
示例 3
输入:digits = “2”
输出:[“a”,“b”,“c”]
提示
0 <= digits.length <= 4
digits[i] 是范围 [‘2’, ‘9’] 的一个数字。
分析
创建一个长度为10的字符串数组 用来存储’0’ - ‘9’ 按键的对应字母值
把’0’和’1’对应的字符串设置为空字符串
设置一个num变量 用来表示遍历到digits中的第几个数字了
当num == digits.length()时 即找到一种组合 将其加入到结果列表中
然后我们就能根据digits中对应的数字顺序 依次遍历digits每个数字对应的字母值
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 class Solution { List<String> res = new ArrayList <>(); StringBuffer path = new StringBuffer (); public List<String> letterCombinations (String digits) { if (digits.length()==0 ) return res; String[] nums = {"" , "" , "abc" , "def" , "ghi" , "jkl" , "mno" , "pqrs" , "tuv" , "wxyz" }; backTracking(digits, nums, 0 ); return res; } void backTracking (String digits, String[] nums, int num) { if (num==digits.length()){ res.add(path.toString()); return ; } String str = nums[digits.charAt(num)-'0' ]; for (int i = 0 ; i < str.length(); i++) { path.append(str.charAt(i)); backTracking(digits,nums,num+1 ); path.deleteCharAt(path.length()-1 ); } } }
组合总和
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/combination-sum/
问题叙述
给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。
candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。
对于给定的输入,保证和为 target 的不同组合数少于 150 个。
示例 1
输入:candidates = [2,3,6,7], target = 7
输出:[[2,2,3],[7]]
解释:
2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。
7 也是一个候选, 7 = 7 。
仅有这两种组合。
示例 2
输入: candidates = [2,3,5], target = 8
输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3
输入: candidates = [2], target = 1
输出: []
提示
1 <= candidates.length <= 30
1 <= candidates[i] <= 200
candidate 中的每个元素都 互不相同
1 <= target <= 500
分析
还是做减法 画出树状图
每个数字可以重复选取 所以递归的startIndex的参数值设为i
剪枝方法和之前一样 当target < 0 时直接剪枝
当target == 0时 将当前路径加入到结果列表中
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> combinationSum (int [] candidates, int target) { backTracking(candidates, target,0 ); return res; } void backTracking (int [] candidates, int target,int startIndex) { if (target == 0 ) { res.add(new ArrayList <>(path)); return ; } if (target < 0 ) return ; for (int i = startIndex; i < candidates.length; i++) { path.offer(candidates[i]); backTracking(candidates, target - candidates[i],i); path.removeLast(); } } }
组合总和II
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/combination-sum-ii/
问题叙述
给定一个候选人编号的集合 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的组合。
candidates 中的每个数字在每个组合中只能使用 一次 。
注意:解集不能包含重复的组合。
示例 1
输入: candidates = [10,1,2,7,6,1,5], target = 8,
输出:
[
[1,1,6],
[1,2,5],
[1,7],
[2,6]
]
示例 2
输入: candidates = [2,5,2,1,2], target = 5,
输出:
[
[1,2,2],
[5]
]
提示
1 <= candidates.length <= 100
1 <= candidates[i] <= 50
1 <= target <= 30
分析
由于待选数组有重复值
先将待选数组排序
画出树状图
剪枝方法:避免同层选相同元素 这样会产生顺序不同的path结果
代码:if (i > startIndex && candidates[i] == candidates[i - 1]) continue;
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> combinationSum2 (int [] candidates, int target) { Arrays.sort(candidates); backTracking(candidates, target, 0 ); return res; } void backTracking (int [] candidates, int target, int startIndex) { if (target == 0 ) { res.add(new ArrayList <>(path)); return ; } if (target < 0 ) return ; for (int i = startIndex; i < candidates.length; i++) { if (i > startIndex && candidates[i] == candidates[i - 1 ]) continue ; path.offer(candidates[i]); backTracking(candidates, target - candidates[i], i+1 ); path.removeLast(); } } } class Solution { LinkedList<Integer> path = new LinkedList <>(); HashSet<List<Integer>> set = new HashSet <>(); public List<List<Integer>> combinationSum2 (int [] candidates, int target) { Arrays.sort(candidates); backTracking(candidates, target, 0 ); List<List<Integer>> res = new ArrayList <>(set); return res; } void backTracking (int [] candidates, int target, int startIndex) { if (target == 0 ) { set.add(new ArrayList <>(path)); return ; } for (int i = startIndex; i < candidates.length; i++) { if (target - candidates[i] < 0 ) break ; if ( i > startIndex && candidates[i] == candidates[i-1 ]) continue ; path.offer(candidates[i]); backTracking(candidates, target - candidates[i], i + 1 ); path.removeLast(); } } }
子集
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/subsets/
问题叙述
给你一个整数数组 nums ,数组中的元素 互不相同 。返回该数组所有可能的子集(幂集)。
解集 不能 包含重复的子集。你可以按 任意顺序 返回解集。
示例 1
输入:nums = [1,2,3]
输出:[[],[1],[2],[1,2],[3],[1,3],[2,3],[1,2,3]]
示例 2
输入:nums = [0]
输出:[[],[0]]
提示
1 <= nums.length <= 10
-10 <= nums[i] <= 10
nums 中的所有元素 互不相同
分析
不能选重复元素 所以递归中startIndex的参数值设为i+1
遍历到的每一个节点都是子集 不需要return;结束方法
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> subsets (int [] nums) { backTracking(nums, 0 ); return res; } void backTracking (int [] nums, int startIndex) { res.add(new ArrayList <>(path)); for (int i = startIndex; i < nums.length; i++) { path.offer(nums[i]); backTracking(nums, i + 1 ); path.removeLast(); } } }
子集II
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/subsets-ii/
问题叙述
给你一个整数数组 nums ,其中可能包含重复元素,请你返回该数组所有可能的子集(幂集)。
解集 不能 包含重复的子集。返回的解集中,子集可以按 任意顺序 排列。
示例 1
输入:nums = [1,2,2]
输出:[[],[1],[1,2],[1,2,2],[2],[2,2]]
示例 2
输入:nums = [0]
输出:[[],[0]]
提示
1 <= nums.length <= 10
-10 <= nums[i] <= 10
分析
待选数组中有重复元素 所以去重方法和 组合总和II 一样 先将待排数组排序
if (i > startIndex && nums[i] == nums[i - 1]) continue;
不能选重复元素 所以startIndex参数值设为i+1
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> subsetsWithDup (int [] nums) { Arrays.sort(nums); backTracking(nums, 0 ); return res; } void backTracking (int [] nums, int startIndex) { res.add(new ArrayList <>(path)); for (int i = startIndex; i < nums.length; i++) { if (i > startIndex && nums[i] == nums[i - 1 ]) continue ; path.offer(nums[i]); backTracking(nums, i + 1 ); path.removeLast(); } } }
递增子序列
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/increasing-subsequences/
问题叙述
给你一个整数数组 nums ,找出并返回所有该数组中不同的递增子序列,递增子序列中 至少有两个元素 。你可以按 任意顺序 返回答案。
数组中可能含有重复元素,如出现两个整数相等,也可以视作递增序列的一种特殊情况。
示例 1
输入:nums = [4,6,7,7]
输出:[[4,6],[4,6,7],[4,6,7,7],[4,7],[4,7,7],[6,7],[6,7,7],[7,7]]
示例 2
输入:nums = [4,4,3,2,1]
输出:[[4,4]]
提示
1 <= nums.length <= 15
-100 <= nums[i] <= 100
分析
待排数组中有重复元素 但是这次又不能排序
分类讨论
每次遍历时 当path.size>=2时 加入到结果数组中
当path中没有元素时 直接将当前元素加入
当path中有元素时 需判断当前元素是否大于末尾元素
否则跳过当前循环
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 class Solution { LinkedList<Integer> path = new LinkedList <>(); List<List<Integer>> res = new ArrayList <>(); HashSet<List<Integer>> set = new HashSet <>(); public List<List<Integer>> findSubsequences (int [] nums) { backTracking(nums, 0 ); res.addAll(set); return res; } void backTracking (int [] nums, int startIndex) { if (path.size() >= 2 ) set.add(new ArrayList <>(path)); for (int i = startIndex; i < nums.length; i++) { if (path.size() == 0 ) path.add(nums[i]); else if (nums[i] >= path.getLast()) path.add(nums[i]); else continue ; backTracking(nums, i + 1 ); path.removeLast(); } } }
全排列
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/permutations/
问题叙述
给定一个不含重复数字的数组 nums ,返回其 所有可能的全排列 。你可以 按任意顺序 返回答案。
示例 1
输入:nums = [1,2,3]
输出:[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]
示例 2
输入:nums = [0,1]
输出:[[0,1],[1,0]]
示例 3
输入:nums = [1]
输出:[[1]]
提示
1 <= nums.length <= 6
-10 <= nums[i] <= 10
nums 中的所有整数 互不相同
分析
当path长度等于数组长度时 将当前path加入到结果中
无脑遍历即可 如果path中包含当前元素 直接跳过
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> permute (int [] nums) { backTracking(nums); return res; } void backTracking (int [] nums) { if (path.size() == nums.length) { res.add(new ArrayList <>(path)); return ; } for (int num : nums) { if (path.contains(num)) continue ; path.offer(num); backTracking(nums); path.removeLast(); } } }
全排列II
来源:力扣(Leetcode)
链接:https://leetcode-cn.com/problems/permutations-ii/
问题叙述
给定一个可包含重复数字的序列 nums ,按任意顺序 返回所有不重复的全排列。
示例 1
输入:nums = [1,1,2]
输出:
[[1,1,2],
[1,2,1],
[2,1,1]]
示例 2
输入:nums = [1,2,3]
输出:[[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]
提示
1 <= nums.length <= 8
-10 <= nums[i] <= 10
nums 中的所有整数 互不相同
分析
看这篇题解就好啦
Code
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 class Solution { List<List<Integer>> res = new ArrayList <>(); LinkedList<Integer> path = new LinkedList <>(); public List<List<Integer>> permuteUnique (int [] nums) { boolean [] used = new boolean [nums.length]; Arrays.fill(used, false ); Arrays.sort(nums); backTracking(nums,used); return res; } void backTracking (int [] nums, boolean [] used) { if (path.size() == nums.length) { res.add(new ArrayList <>(path)); return ; } for (int i = 0 ; i < nums.length; i++) { if (used[i]) continue ; if (i > 0 && nums[i] == nums[i - 1 ] && !used[i - 1 ]) continue ; path.offer(nums[i]); used[i] = true ; backTracking(nums, used); path.removeLast(); used[i] = false ; } } }